## Virtual Environment Installation
#### Idiap Research Institute
##### Switzerland - 2019

#### Check Prerequisites

Check out your python, pip, and virtualenv installation:

````
python --version
````

````
pip --version
````

````
virtualenv --version
````

If virtualenv is not installed, please install it via pip:

````
pip install virtualenv
````

Test your installation:

````
virtualenv --version
````

#### Create virtual environment

Create a name for the virtual environment (eg. env_dtrees):

````
ENV_NAME=env_dtrees
````

Create virtual environment (python 3):

````
virtualenv -p python3 $ENV_NAME
````

Activate virtual environment:

````
source ./$ENV_NAME/bin/activate
````

#### Install requirements

````
pip install -r requirements.txt
````
